classdef UsbDevice < handle
  % UsbDevice
  %   USB device
  %
  % Methods:
  %   serial - Get serial corresponding with USB device
  %

  properties(Access=protected)
    mPtr = uint64(0);
  end

  methods(Access=public)
    function obj = UsbDevice(varargin)
      % UsbDevice
      %   Construct new usb_device class
      %

      if nargin == 1 && isa(varargin{1}, 'uint64')
        obj.mPtr = varargin{1};
      else
        error("Can't construct empty object");
      end
    end


    function delete(obj)
      if obj.mPtr ~= 0
        tof.mex('tof_usb_device_delete', obj.mPtr);
        obj.mPtr = 0;
      end
    end

    function ptr = get_object_ptr(obj)
      ptr = obj.mPtr;
    end

    function ret_val = serial(obj)
      % serial
      %   Get serial corresponding with USB device
      %
      % Output:
      %   ret_val - string - Serial
      %

      ret_val = tof.mex('tof_usb_device_serial', obj.mPtr);
    end

  end
end
